const text = document.getElementById('textArea');
const scrambleButton = document.getElementById('submitButton');
const textField = document.getElementById('textField');
const optionButton = document.getElementById('option');
const info = document.getElementById('info');
const infoContainer = document.getElementById('infoContainer');



function scramble(event){
    
    let sentence = text.value;
    let trimmedText = sentence.trim();
    let splitText = trimmedText.split(' ');
    let finalSentence = [];

while(splitText.length > 0){
    let random = Math.floor(Math.random() * splitText.length);
    finalSentence.push(splitText.splice(random,1));
}
finalSentence = finalSentence.join(' ');
textField.innerHTML = finalSentence;

optionButton.addEventListener('click', function(event){
    let splittedText = trimmedText.split(' ');
    let wordCount = splittedText.length;
    let charCount = trimmedText.length;
    info.innerHTML = "amount of words: " + wordCount + "<br />" + "amount of characters: " + charCount;
    infoContainer.style.visibility = "visible";
});
}



scrambleButton.addEventListener('click',scramble);
