const form = document.getElementById('form');
const addButton = document.getElementById('addButton');
const textField = document.getElementById('textField');

let xButtons =  document.querySelectorAll('.xButton');
            xButtons.forEach(function(element) {
                element.style.display = 'none';
            });

function addInput(event){
    event.preventDefault();
    //elementen aanmaken
    var newSpan = document.createElement('span');
    var spanText = document.createTextNode('number: ');
    var newInput = document.createElement('input');
    newInput.setAttribute('type','number');
    newInput.setAttribute('value','0');
    var newButton = document.createElement('button');
    var buttonText = document.createTextNode('x');
    newButton.setAttribute('class','xButton');
    var newBreak = document.createElement('br');
   //child toevoegen
    newButton.appendChild(buttonText);
    newSpan.append(spanText,newInput,newButton,newBreak);
    form.appendChild(newSpan);
    
    
}

function deleteInput(event){
    event.preventDefault();
    if(event.target.matches('.xButton')){
        if(form.children.length > 2){
            console.log(form.children.length);
            event.target.closest('span').remove();
        }
    }
    
}

function calculate(event){
    var inputs = document.querySelectorAll('input');
    var sumResult = 0;
    var productResult = 1;

    for(var i = 0; i < inputs.length;i++){
        sumResult += parseInt(inputs[i].value);
        productResult *= parseInt(inputs[i].value);
    }

    textField.innerHTML = "som: " + sumResult + "<br>" + "product: " + productResult;

}


addButton.addEventListener('click',addInput);
form.addEventListener('click',deleteInput);
form.addEventListener('input',calculate);